<?php

/*
=====================================================
 Plugin: Custom Text
-----------------------------------------------------
 Author: Joshua Jabbour
 Updated by 4KSNER!
 
 Внимание!
 Если вы используете параметр file="имя_файла", убедитесь
 что ваш файл лежит в папке с языком, и имя его заканчивается на "_lang"!
 
 
 
 
 Version: 0.5.0
-----------------------------------------------------
 Some code contained within this plugin is 
 courtesy of pMachine.
=====================================================
 File: pi.custom_text.php
-----------------------------------------------------
 Purpose: This plugin provides tags that display text
 from system language files. It also allows the use
 of custom language files to contain often used text
 strings.
 
 
 
 
=====================================================
*/

$plugin_info = array(
	'pi_name' => 'Custom Text',
	'pi_version' =>'0.5.0',
	'pi_author' =>'Joshua Jabbour',
	'Updated by' =>'4ksner',
	'E-mail' =>'foksner@yandex.ru',
	'pi_author_url' => 'http://4ksner.ru/',
	'pi_description' => 'Displays text from language files.',
	'pi_usage' => Custom_text::usage()
);

class Custom_text {  
	var $return_data = '';
	
	public	function Custom_text() {
		global $TMPL, $SESS, $IN, $PREFS, $LANG, $FNS;
		$file_prefixes = array('lang.','mod.','pi.','ext.');
		$file_suffixes = array('.php','.txt','.htm','.html');
		
		$this->EE =& get_instance();
		
		$the_string = trim(strtolower($this->EE->TMPL->fetch_param('string')));
		
		if ($the_string == '') { // NO STRING
					
			$the_file = $this->EE->security->sanitize_filename(trim(strtolower($this->EE->TMPL->fetch_param('file'))));
			if ($the_file == '') { // NO FILE
				
				$this->return_data = $the_string;
				return;
				
			} else { // YES FILE
				
				foreach ($file_prefixes as $value) {
					if (strpos($the_file, $value)) {
						$the_file = str_replace($value, '', $the_file);
					}
				}
				foreach ($file_suffixes as $value) {
					if (strpos($the_file, $value)) {
						$the_file = str_replace($value, '', $the_file);
					}
				}
				
			}
			
			$the_lang = '';
			if ( $this->EE->session->userdata['language'] != '') {
				$the_lang = $this->EE->session->userdata['language'];
			} else {
				if ($this->EE->input->cookie('language')) {
					$the_lang = $IN->GBL('language', 'COOKIE');
				} elseif ( $this->EE->config->item('deft_lang') != '') {
					$the_lang = $this->EE->config->item('deft_lang');
				} else {
					$the_lang = 'english';
				}
			}
			$the_lang = $this->EE->security->sanitize_filename($the_lang);

			$this->EE->lang->loadfile($the_file);
			$this->return_data = $the_string;
			return;
			
		} else { // YES STRING
			
			$the_file =  $this->EE->security->sanitize_filename(trim(strtolower($this->EE->TMPL->fetch_param('file'))));
			
			if ($the_file == '') { // NO FILE
				
				
				$trans_string = '';
				$this->EE->lang->loadfile("custom_text");
				$trans_string = $this->EE->lang->line($the_string);
				if ($trans_string != '') {
					$this->return_data = $trans_string;
					return;
				}
				
			} else { // YES FILE
				
				foreach ($file_prefixes as $value) {
					if (strpos($the_file, $value)) {
						$the_file = str_replace($value, '', $the_file);
					}
				}
				foreach ($file_suffixes as $value) {
					if (strpos($the_file, $value)) {
						$the_file = str_replace($value, '', $the_file);
					}
				}
				
			}
			
			$the_lang = '';
			if ($SESS->userdata['language'] != '') {
				$the_lang = $SESS->userdata['language'];
			} else {
				if ($IN->GBL('language', 'COOKIE')) {
					$the_lang = $IN->GBL('language', 'COOKIE');
				} elseif ($PREFS->ini('deft_lang') != '') {
					$the_lang = $PREFS->ini('deft_lang');
				} else {
					$the_lang = 'english';
				}
			}
			
			$the_lang = $FNS->filename_security($the_lang);
			
			if ($the_file == '' AND is_file(PATH_LANG.$the_lang.'/lang.my_custom_text'.EXT)) {
				$the_file = 'my_custom_text';
			}
			
			if (!is_file(PATH_LANG.$the_lang.'/lang.'.$the_file.EXT)) {
				$trans_string = '';
				$trans_string = $LANG->line($the_string);
				if ($trans_string != '') {
					$this->return_data = $trans_string;
					return;
				} else {
					$this->return_data = $the_string;
					return;
				}
			}
			
			$LANG->fetch_language_file($the_file);
			$trans_string = $LANG->line($the_string);
			if ($trans_string != '') {
				$this->return_data = $trans_string;
			} else {
				$this->return_data = $the_string;
			}	
		}  
	}
	
	
	public function usage() {
		ob_start(); 
?>
The Custom Text plugin returns text specified by the {exp:custom_text} tag.



Внимание!!!
 Если вы используете параметр file="имя_файла", убедитесь
 что ваш файл лежит в папке с языком, и имя его заканчивается на "_lang"!
По умолчанию используется файл: custom_text_lang.php!



=== PARAMETERS ===

** string **
The "string" parameter tells the Custom Fields plugin to display text that corresponds to the provided parameter.

If a "file" parameter is given in the same tag {exp:custom_text string="string" file="file"}, that file will be used to locate the string. If no "file" parameter is given in a tag {exp:custom_text string="string"}, the Custom Fields plugin will see if the string is available from an already loaded file. If the string cannot be located, the string itself will be displayed.

** file **
The "file" parameter tells the Custom Fields plugin to load a language file that corresponds to the provided parameter.

Individual {exp:custom_text file="file"} tags should be loaded as early in the template as possible, as their values will only be available to subsequent {exp:custom_text string="string"} tags.

The "file" parameter should contain the name of the module, plugin, or extension from which you want to use strings. It should be provided exactly as it appears in the languages folder (without the prefix "lang." or suffix ".php"). If no "file" parameter is given anywhere in the template, the plugin will attempt to use the included "custom_text_lang.php" file.

The user's default language is always used (or if the user is anonymous, the system's default language is used).

If more than one file contains the same string key, unexpected results may occur. If this happens, be sure to specify the exact file to use with a {exp:custom_text string="string" file="file"} tag.

{exp:custom_text} tags can be placed in different levels within embedded templates. {exp:custom_text string="string"} tags should work as long as an {exp:custom_text file="file"} tag is somewhere upstream.


=== EXAMPLE USAGE ===

-----
This EE Code:
{exp:custom_text string="search_module_name" file="search"}

Returns this text:
Search
-----
This EE Code:
{exp:custom_text file="search"}
{exp:custom_text string="search_module_name"}
{exp:custom_text string="search_no_result"}

Returns this text:
Search
Your search did not return any results.
-----
This EE Code:
{exp:custom_text file="search"}
{exp:custom_text file="member"}
{exp:custom_text string="search_no_result"}
{exp:custom_text string="query_module_name" file="query"}
{exp:custom_text string="choose_new_un"}

Returns this text:
Your search did not return any results.
Query
Please choose a new username
----- 


=== CUSTOM LANGUAGE FILES ===

This most useful aspect of this plugin is that it can be used to create custom language files. Simply place the included "lang.my_custom_text.php" file in your language folders to get started (more than one custom language file can be used).

("my_custom_text" can be any string, though to avoid conflicting with other files you should probably use a prefix e.g. "mydomain_custom_text". Additionally, for best results be sure the string keys within the language file are unique, again use a prefix e.g. "mydomain_string1", "mydomain_string2", etc.)


<?php
		$buffer = ob_get_contents();
		
		ob_end_clean();
		
		return $buffer;
	}

}

?>